# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

%define lift_available 0

Summary:        HTTP interactions for Scala
Name:           databinder-dispatch_2.8.1
Version:        0.7.8
Release:        1%{?dist}
Epoch:          0
Group:          Development/Framework
License:        ASL 2.0
URL:            http://dispatch-classic.databinder.net/Dispatch.html
Source0:        databinder-dispatch-0.7.8.tar.bz2
# git clone https://github.com/dispatch/dispatch.git
# git archive --prefix="databinder-dispatch-0.7.8/" --format=tar 0.7.8 | bzip2 > ../../SOURCES/databinder-dispatch-0.7.8.tar.bz2

Source1:        http://repo1.maven.org/maven2/net/databinder/dispatch-couch_2.8.1/0.7.8/dispatch-couch_2.8.1-0.7.8.pom
Source2:        http://repo1.maven.org/maven2/net/databinder/dispatch-futures_2.8.1/0.7.8/dispatch-futures_2.8.1-0.7.8.pom
Source3:        http://repo1.maven.org/maven2/net/databinder/dispatch-google_2.8.1/0.7.8/dispatch-google_2.8.1-0.7.8.pom
Source4:        http://repo1.maven.org/maven2/net/databinder/dispatch-http-json_2.8.1/0.7.8/dispatch-http-json_2.8.1-0.7.8.pom
Source5:        http://repo1.maven.org/maven2/net/databinder/dispatch-http_2.8.1/0.7.8/dispatch-http_2.8.1-0.7.8.pom
Source6:        http://repo1.maven.org/maven2/net/databinder/dispatch-json_2.8.1/0.7.8/dispatch-json_2.8.1-0.7.8.pom
Source7:        http://repo1.maven.org/maven2/net/databinder/dispatch-lift-json_2.8.1/0.7.8/dispatch-lift-json_2.8.1-0.7.8.pom
Source8:        http://repo1.maven.org/maven2/net/databinder/dispatch-meetup_2.8.1/0.7.8/dispatch-meetup_2.8.1-0.7.8.pom
Source9:        http://repo1.maven.org/maven2/net/databinder/dispatch-mime_2.8.1/0.7.8/dispatch-mime_2.8.1-0.7.8.pom
Source10:       http://repo1.maven.org/maven2/net/databinder/dispatch-oauth_2.8.1/0.7.8/dispatch-oauth_2.8.1-0.7.8.pom
Source11:       http://repo1.maven.org/maven2/net/databinder/dispatch-s3_2.8.1/0.7.8/dispatch-s3_2.8.1-0.7.8.pom
Source12:       http://repo1.maven.org/maven2/net/databinder/dispatch-times_2.8.1/0.7.8/dispatch-times_2.8.1-0.7.8.pom
Source13:       http://repo1.maven.org/maven2/net/databinder/dispatch-twitter_2.8.1/0.7.8/dispatch-twitter_2.8.1-0.7.8.pom
Source14:       http://repo1.maven.org/maven2/net/databinder/dispatch_2.8.1/0.7.8/dispatch_2.8.1-0.7.8.pom

Patch0:         databinder-dispatch-mime-Mime.patch
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  scala28
Requires:  apache-commons-codec
Requires:  apache-commons-logging
Requires:  apache-mime4j
Requires:  hc-httpcore
Requires:  hc-httpclient
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  scala28
BuildRequires:  scala-2.8.1-specs
BuildRequires:  apache-commons-codec
BuildRequires:  apache-commons-logging
BuildRequires:  apache-mime4j
BuildRequires:  hc-httpcore
BuildRequires:  hc-httpclient
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Dispatch is a library for conducting HTTP interaction. You 
tell it what to do in pure and uninhibited Scala, and 
Dispatch carries out your orders using its trusty 
HttpClient backend. 

%package scaladoc
Group:          Development/Documentation
Summary:        Scaladoc for %{name}

%description scaladoc
%{summary}.

%prep
%setup -q -n databinder-dispatch-%{version}
%patch0 -b .sav0

%build
mkdir lib
export DLIB=$(pwd)/lib
echo == FUTURES ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
)
pushd futures
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-futures_2.8.1-%{version}.jar -C classes dispatch
popd
echo == FUTURES ==

echo == JSON ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
)
pushd json
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-json_2.8.1-%{version}.jar -C classes dispatch
popd
echo == JSON ==

echo == HTTP ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
commons-codec \
commons-logging \
):${DLIB}/dispatch-futures_2.8.1-%{version}.jar
pushd http
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-http_2.8.1-%{version}.jar -C classes dispatch
popd
echo == HTTP ==

echo == MIME ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
httpcomponents/httpmime \
apache-mime4j/core \
):${DLIB}/dispatch-http_2.8.1-%{version}.jar
pushd mime
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-mime_2.8.1-%{version}.jar -C classes dispatch
popd
echo == MIME ==

echo == HTTP+JSON ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
commons-codec \
commons-logging \
):${DLIB}/dispatch-http_2.8.1-%{version}.jar:${DLIB}/dispatch-json_2.8.1-%{version}.jar
pushd http+json
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-http-json_2.8.1-%{version}.jar -C classes dispatch
popd
echo == HTTP+JSON ==

echo == TIMES ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
):${DLIB}/dispatch-http_2.8.1-%{version}.jar:${DLIB}/dispatch-json_2.8.1-%{version}.jar:${DLIB}/dispatch-http-json_2.8.1-%{version}.jar
pushd times
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-times_2.8.1-%{version}.jar -C classes dispatch
popd
echo == TIMES ==

echo == COUCH ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
):${DLIB}/dispatch-http_2.8.1-%{version}.jar:${DLIB}/dispatch-json_2.8.1-%{version}.jar:${DLIB}/dispatch-http-json_2.8.1-%{version}.jar
pushd couch
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-couch_2.8.1-%{version}.jar -C classes dispatch
popd
echo == COUCH ==

echo == AWS-S3 ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
commons-codec \
):${DLIB}/dispatch-http_2.8.1-%{version}.jar
pushd aws-s3
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-s3_2.8.1-%{version}.jar -C classes dispatch
popd
echo == AWS-S3 ==

echo == OAUTH ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
commons-codec \
):${DLIB}/dispatch-http_2.8.1-%{version}.jar
pushd oauth
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-oauth_2.8.1-%{version}.jar -C classes dispatch
popd
echo == OAUTH ==

echo == GOOGLE ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
):${DLIB}/dispatch-http_2.8.1-%{version}.jar
pushd google
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-google_2.8.1-%{version}.jar -C classes dispatch
popd
echo == GOOGLE ==

%if %lift_available

echo == MEETUP ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
)
#httpcomponents/httpcore \
#httpcomponents/httpclient \
#):${DLIB}/dispatch-http_2.8.1-%{version}.jar
pushd meetup
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-meetup_2.8.1-%{version}.jar -C classes dispatch
popd
echo == MEETUP ==

echo == LIFT-JSON ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
)
pushd lift-json
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-lift-json_2.8.1-%{version}.jar -C classes dispatch
popd
echo == LIFT-JSON ==

echo == TWITTER ==
CLASSPATH=$(build-classpath \
scala28/scala28-library \
scala-2.8.1-specs/specs_2.8.1 \
httpcomponents/httpcore \
httpcomponents/httpclient \
):$(pwd)/oauth/target/classes:$(pwd)/http/target/classes:$(pwd)/json/target/classes:$(pwd)/http+json/target/classes:$(pwd)/oauth/target/classes
pushd twitter
mkdir -p classes
scalac28 -classpath ${CLASSPATH} -d classes/ $(find . -name "*.scala")
jar cf ${DLIB}/dispatch-twitter_2.8.1-%{version}.jar -C classes dispatch
popd
echo == TWITTER ==

%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-couch_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-couch_2.8.1 %{version} JPP/%{name} dispatch-couch_2.8.1
install -m 644 lib/dispatch-couch_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-couch_2.8.1-%{version}.jar

install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-futures_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-futures_2.8.1 %{version} JPP/%{name} dispatch-futures_2.8.1
install -m 644 lib/dispatch-futures_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-futures_2.8.1-%{version}.jar

install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-google_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-google_2.8.1 %{version} JPP/%{name} dispatch-google_2.8.1
install -m 644 lib/dispatch-google_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-google_2.8.1-%{version}.jar

install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-http-json_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-http-json_2.8.1 %{version} JPP/%{name} dispatch-http-json_2.8.1
install -m 644 lib/dispatch-http-json_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-http-json_2.8.1-%{version}.jar

install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-http_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-http_2.8.1 %{version} JPP/%{name} dispatch-http_2.8.1
install -m 644 lib/dispatch-http_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-http_2.8.1-%{version}.jar

install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-json_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-json_2.8.1 %{version} JPP/%{name} dispatch-json_2.8.1
install -m 644 lib/dispatch-json_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-json_2.8.1-%{version}.jar

install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-lift-json_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-lift-json_2.8.1 %{version} JPP/%{name} dispatch-lift-json_2.8.1
#install -m 644 lib/dispatch-lift-json_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-lift-json_2.8.1-%{version}.jar

install -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-meetup_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-meetup_2.8.1 %{version} JPP/%{name} dispatch-meetup_2.8.1
#install -m 644 lib/dispatch-meetup_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-meetup_2.8.1-%{version}.jar

install -m 644 %{SOURCE9} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-mime_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-mime_2.8.1 %{version} JPP/%{name} dispatch-mime_2.8.1
install -m 644 lib/dispatch-mime_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-mime_2.8.1-%{version}.jar

install -m 644 %{SOURCE10} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-oauth_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-oauth_2.8.1 %{version} JPP/%{name} dispatch-oauth_2.8.1
install -m 644 lib/dispatch-oauth_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-oauth_2.8.1-%{version}.jar

install -m 644 %{SOURCE11} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-s3_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-s3_2.8.1 %{version} JPP/%{name} dispatch-s3_2.8.1
install -m 644 lib/dispatch-s3_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-s3_2.8.1-%{version}.jar

install -m 644 %{SOURCE12} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-times_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-times_2.8.1 %{version} JPP/%{name} dispatch-times_2.8.1
install -m 644 lib/dispatch-times_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-times_2.8.1-%{version}.jar

install -m 644 %{SOURCE13} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch-twitter_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch-twitter_2.8.1 %{version} JPP/%{name} dispatch-twitter_2.8.1
#install -m 644 lib/dispatch-twitter_2.8.1-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dispatch-twitter_2.8.1-%{version}.jar

install -m 644 %{SOURCE14} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dispatch_2.8.1.pom
%add_to_maven_depmap net.databinder dispatch_2.8.1 %{version} JPP/%{name} dispatch_2.8.1

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%changelog
* Thu Jan 17 2013 Ralph Apel <r.apel@r-apel.de> 0:0.7.8-1
- 0.7.8 

